package ssw.mj;

import java.io.PrintWriter;

/** 
 * The parser for the MicroJava Compiler. 
 * 
 * @author AW
 */
public class Parser {

	private static PrintWriter out;

	/** Last recognized token; */
	private static Token t;
  
	/** Lookahead token (not recognized).) */
	private static Token la;
  
	/** Shortcut to kind attribute of lookahead token (la). */
	private static int sym;

	/** Reads ahead one symbol. */
	private static void scan () {
		/* ------------------------------
		 * TODO: place your own code here
		 * ------------------------------
		 */
	}
	
	/** Verifies symbol and reads ahead. */
	private static void check (int expected) {
		/* ------------------------------
		 * TODO: place your own code here
		 * ------------------------------
		 */
	}

	/** Program = "class" ident { ConstDecl | VarDecl | ClassDecl } 
	 *            "{" { MethodDecl } "}" . */
	private static void Program () {
		/* ------------------------------
		 * TODO: place your own code here
		 * ------------------------------
		 */
	}

	/* ---------------------------------
	 * TODO: insert parsing methods here
	 * ---------------------------------
	 */

	/** Starts the analysis. 
	 *	Output is written to System.out.
	 */
	public static void parse () { parse(new PrintWriter(System.out, true)); }
	
	/** Starts the analysis.
	 *  Initializes the parser and all its components.
	 *	Output is written to <code>PrintStream</code> provided in <code>output</code>
	 */
	public static void parse (PrintWriter output) {
		out = output;

		/* ------------------------------
		 * TODO: place your own code here
		 * ------------------------------
		 */
	}
	
	/** Handles all compiler errors. */
	public static class Errors {
		/** Prints an error message of the format<br>
		 *  <code>-- line <i>line no.</i>, col <i>column no.</i>: <i>message</i></code><br>
		 */
		public static void error (String prefix, String msgKey, String postfix) {
			StringBuffer msg = new StringBuffer();
			msg.append("-- line ");
			msg.append(la.line);
			msg.append(", col ");
			msg.append(la.col);
			msg.append(": ");
			msg.append(prefix);
			if (msgKey != null) msg.append(Messages.getString(msgKey)); 
			msg.append(postfix);
			out.println(msg.toString());	
			throw new Error(Messages.getString("PANIC_MODE"));
		}
		public static void error (String msgKey) { error("", msgKey, ""); }
	}
}
